// PALib Template Application

// Includes
#include <PA9.h>       // Include for PA_Lib

#include "win.h"
#include "start.h" // gif to include
#include "neoflash.h" // gif to include
//#include <fat.h>

#include "gfx/all_gfx.c" 
#include "gfx/all_gfx.h"

#include "tangram.h"

bool	bHelpUse=false;//Ǹ 1 밡
u8		nAnswerIdx=0;
TANGRAM stCurTangram;
u8		nFocusX=0;//0~7
u8		nFocusY=0;//0~8
bool	bNewGame=true;
s8		nSelSprite;

void SleepDS(u8 secs);
void ShowAnswer();
void WritePosition();
void ArrangeTangramBg(TANGRAM stAnswer);
bool CheckAnswerTangram(TANGRAM stAnswer);
void InitTangram();
void SetFocus(u8 nSelSprite);
void ShowHint();
void SetAnswer();
void SetRandom();
void SetSummaryFocus(u8 nPosX, u8 nPosY);

int main()
{
	PA_Init();    // Initializes PA_Lib
	PA_InitVBL(); // Initializes a standard VBL
	PA_InitSound(); 	// Sound Init, for the mod player...

	PA_Init8bitBg(0, 0); 	// Init a 8 bit Bg on screen 0
	PA_Init8bitBg(1, 0); 	// Init a 8 bit Bg on screen 1	

	PA_SetBrightness(0, -31); // all black
	PA_SetBrightness(1, -31); // all black	
	
	// Load splash while hidden
	PA_LoadGif(	1, (void*)start); // Gif File
	PA_LoadGif(	0, (void*)neoflash); // Gif File

	s8 i;
	// Transition to normal visible background
	for(i = -31; i <= 0; i++){
		PA_SetBrightness(0, i); 
		PA_SetBrightness(1, i); 
		PA_WaitForVBL();		   
	}

	s16 time = 180; // 180 frames = 3 seconds
	while(time && (!Pad.Newpress.Anykey) && (!Stylus.Newpress)){ // Display until time over or keys pressed
		time--; // time goes by
		PA_WaitForVBL();
	}	
	// Transition to black
	for(i = 0; i > -32; i--){
		PA_SetBrightness(0, i); 
		PA_SetBrightness(1, i); 
		PA_WaitForVBL();		   
	}  	

	// Now that it's all black, clean all that and you're ready to go !
	PA_ResetBgSys();
	PA_SetBrightness(0, 0); // normal
	PA_SetBrightness(1, 0); // normal		

	/////////////////////////////////////
	PA_Init3D(); // Uses Bg0
	PA_Reset3DSprites();
	PA_InitText(SCREEN_TOP, BG_TOP_TXT);  
	PA_InitText(SCREEN_BTM, BG_BTM_TXT);

	PA_WaitForVBL();  PA_WaitForVBL();  PA_WaitForVBL();  // wait a few VBLs
	
	//fatInitDefault(); //Initialise fat library

	//PA_LoadTiledBg (SCREEN_TOP,BG_START, start);
	
	PA_LoadSpritePal(SCREEN_TOP, 0, (void*)summary_focus_Pal);
	// Load the Palettes !
	PA_Load3DSpritePal(0, // Slot
							(void*)ltriangle_bg_Pal); // Palette
	PA_Load3DSpritePal(1, (void*)mtriangle_bg_Pal);		
	PA_Load3DSpritePal(2, (void*)striangle_bg_Pal);	
	PA_Load3DSpritePal(3, (void*)square_bg_Pal);		
	PA_Load3DSpritePal(4, (void*)parrellel_bg_Pal);	

	PA_Load3DSpritePal(5, (void*)ltriangle_Pal); // Palette
	PA_Load3DSpritePal(6, (void*)mtriangle_Pal);		
	PA_Load3DSpritePal(7, (void*)striangle_Pal);	
	PA_Load3DSpritePal(8, (void*)square_Pal);		
	PA_Load3DSpritePal(9, (void*)parrellel_Pal);	
	PA_Load3DSpritePal(10, (void*)search_Pal);	

	PA_Load3DSpritePal(11, (void*)large_focus_Pal);		
	PA_Load3DSpritePal(12, (void*)middle_focus_Pal);	
	PA_Load3DSpritePal(13, (void*)small_focus_Pal);	

	PA_Load3DSpritePal(15, (void*)tangram_Pal);//background

	PA_CreateSprite(SCREEN_TOP,0,(void*)summary_focus_Sprite,OBJ_SIZE_64X64,1,0,0,0);
	PA_SetSpritePrio(SCREEN_TOP,0,3);
	PA_SetSpriteAnim(SCREEN_TOP,0,1);

	PA_3DCreateSprite(10, (void*)ltriangle_bg_Texture, 64, 64,TEX_256COL, 0,-64, 0); 
	PA_3DCreateSprite(11, (void*)ltriangle_bg_Texture, 64, 64, TEX_256COL, 0, -64, 192-32);
	PA_3DCreateSprite(12, (void*)mtriangle_bg_Texture, 64, 32, TEX_256COL, 1, 128+16, -32);
	PA_3DCreateSprite(13, (void*)striangle_bg_Texture, 	32, 32, TEX_256COL, 2, 	256+32, 16);
	PA_3DCreateSprite(14, (void*)striangle_bg_Texture, 	32, 32, TEX_256COL, 2, 	256+32, 96);
	PA_3DCreateSprite(15, (void*)square_bg_Texture, 	32, 32, TEX_256COL, 3, 	128+16, 192+32);
	PA_3DCreateSprite(16, (void*)parrellel_bg_Texture, 	32, 64, TEX_256COL, 4, 	256+32, 192);

	PA_3DCreateSprite(0, (void*)ltriangle_Texture, 64, 64, 				// Width, Height
							TEX_256COL, 5,   		// Palette, unused in 16bit...
							32, 32); // X, Y SPRITE CENTER !
	PA_3DCreateSprite(1, (void*)ltriangle_Texture, 64, 64, TEX_256COL, 5, 32, 160);
	PA_3DCreateSprite(2, (void*)mtriangle_Texture, 64, 32, TEX_256COL, 6, 144, 16);
	PA_3DCreateSprite(3, (void*)striangle_Texture, 	32, 32, TEX_256COL, 7, 	240, 48);
	PA_3DCreateSprite(4, (void*)striangle_Texture, 	32, 32, TEX_256COL, 7, 	240, 112);
	PA_3DCreateSprite(5, (void*)square_Texture, 	32, 32, TEX_256COL, 8, 	144, 176);
	PA_3DCreateSprite(6, (void*)parrellel_Texture, 	32, 64, TEX_256COL, 9, 	240, 160);

	PA_3DCreateSprite(NUM_SEARCH_SPRITE, (void*)search_Texture, 	32, 32, TEX_256COL, 10, 	256-15, 17);
	PA_3DCreateSprite(21, (void*)large_focus_Texture, 64, 64, TEX_256COL, 11, -64, 192-32);
	PA_3DCreateSprite(22, (void*)middle_focus_Texture, 64, 32, TEX_256COL, 12, 128+16, -32);
	PA_3DCreateSprite(23, (void*)small_focus_Texture, 	32, 32, TEX_256COL, 13, 	256+32, 16);

	PA_3DCreateSprite(25, (void*)tangram_Texture, 	256, 256, TEX_256COL, 15, 128, 128);//background
	
	nSelSprite=0;
	stCurTangram.bFlip=false;//纯 
	
	for(i=0;i<3;i++)
	{
		PA_3DSetSpritePrio(21+i, 1024 + 15);
	}
	for(i=0;i<7;i++)
	{
		stCurTangram.nAngle[i]=0;
		PA_3DSetSpritePrio(i, 1024 + 10 ); // Priority... (default is 1024)
	}

	char letter[2];

	PA_UsePAGraffiti(0); // Do not use the provided Graffiti shapes...
	
	PA_RecoAddShape('R', "AAAAAAAAAAAAAAA"); // Straight right-going line
	PA_RecoAddShape('L', "111111111111111"); // Straight left-going line	
	PA_RecoAddShape('U', "IIIIIIIIIIIIIII"); // Straight up-going line	
	PA_RecoAddShape('D', "999999999999999"); // Straight down-going line
	
	PA_RecoAddShape('E', "==============="); //NE	
	PA_RecoAddShape('W', "555555555555555"); //NW
	PA_RecoAddShape('N', "EEEEEEEEEEEEEEE"); //SE	
	PA_RecoAddShape('S', "MMMMMMMMMMMMMMM"); //SW
		
	PA_WaitForVBL();
	//SleepDS(20);
	//PA_HideBg(SCREEN_TOP,BG_START);
	
	nAnswerIdx=1;
	PA_LoadTiledBg (SCREEN_TOP,BG_SUMMARY, summary1);

	while(1)
	{
		InitTangram();
		ArrangeTangramBg(stAnswerTangram[nAnswerIdx]);
		//PA_SetTextCol(SCREEN_TOP,0,0,0);
		
		PA_SetSpriteAnim(SCREEN_TOP,0,1);
		while(bNewGame)
		{
			if(Pad.Newpress.Left)
			{
				if(nFocusX>0)
				{
					nFocusX--;
					SetSummaryFocus(nFocusX, nFocusY);
				}
			}
			else if(Pad.Newpress.Right)
			{
				if(nFocusX<7)
				{
					nFocusX++;
					SetSummaryFocus(nFocusX, nFocusY);
				}

			}
			else if(Pad.Newpress.Up)
			{
				if(nFocusY>0)
				{
					nFocusY--;
					SetSummaryFocus(nFocusX, nFocusY);
				}

			}
			else if(Pad.Newpress.Down)
			{
				if(nFocusY<8)
				{
					nFocusY++;
					SetSummaryFocus(nFocusX, nFocusY);
				}

			}

			//if(Pad.Newpress.Left)
			if(Pad.Newpress.A)
			{
				bNewGame=false;
				PA_SetSpriteAnim(SCREEN_TOP,0,0);
				nAnswerIdx=nFocusX+nFocusY*8+1;
				ArrangeTangramBg(stAnswerTangram[nAnswerIdx]);
			}

			PA_WaitForVBL();
		}
		//SetFocus(nSelSprite);
		// Infinite loop to keep the program running
		while (bNewGame==false)
		{
			letter[1] = 0;
			letter[0] = PA_CheckLetter(); // Returns the letter !!!
			
			/*if(Pad.Newpress.L&&Pad.Newpress.R)
			{
				SetAnswer();
				continue;
			}*/
			//select : summary control -> pad -> A : selection -> game start
			//pad : move , Y,A : rotate, X,B : flip, Trigger L,R : sprite selection

			//selection
			if(Pad.Newpress.L)
			{
				if(nSelSprite>0)
				{
					nSelSprite--;

					for(i=0;i<7;i++)
					{
						if(i==nSelSprite)
						{
							PA_3DSetSpritePrio(nSelSprite, 1024 + 10);
							SetFocus(nSelSprite);
						}
						else
							PA_3DSetSpritePrio(i, 1024 + 5 );
					}
				}
				else
				{
					PA_3DSetSpritePrio(0, 1024 + 5 );
					nSelSprite=6;
					PA_3DSetSpritePrio(nSelSprite, 1024 + 10);
					SetFocus(nSelSprite);
				}
			}
			else if(Pad.Newpress.R)
			{
				if(nSelSprite<6)
				{
					nSelSprite++;

					for(i=0;i<7;i++)
					{
						if(i==nSelSprite)
						{
							PA_3DSetSpritePrio(nSelSprite, 1024 + 10);
							SetFocus(nSelSprite);
						}
						else
							PA_3DSetSpritePrio(i, 1024 + 5 );
					}
				}
				else
				{
					PA_3DSetSpritePrio(6, 1024 + 5 );
					nSelSprite=0;
					PA_3DSetSpritePrio(nSelSprite, 1024 + 10);
					SetFocus(nSelSprite);
				}
			}
			//move
			if(Pad.Held.Up)
			{
				SleepDS(1);
				if(stCurTangram.nY[nSelSprite]>8)
				{
					stCurTangram.nY[nSelSprite]=stCurTangram.nY[nSelSprite]-4;

					PA_3DSetSpriteXY(nSelSprite,stCurTangram.nX[nSelSprite],stCurTangram.nY[nSelSprite]);//8pixel  ̰
					SetFocus(nSelSprite);
					//PA_OutputText(1, 2, 1, "sprite[%d] x[%d]y[%d]",nSelSprite, stCurTangram.nX[nSelSprite], stCurTangram.nY[nSelSprite]); // Letter recognized

					if(CheckAnswerTangram(stAnswerTangram[nAnswerIdx]))
					{
						//PA_OutputText(1, 2, 0,"OK collect");
						
					}
				}
			}
			else if(Pad.Held.Down)
			{
				SleepDS(1);
				if(stCurTangram.nY[nSelSprite]<184)
				{
					stCurTangram.nY[nSelSprite]=stCurTangram.nY[nSelSprite]+4;

					PA_3DSetSpriteXY(nSelSprite,stCurTangram.nX[nSelSprite],stCurTangram.nY[nSelSprite]);//8pixel  ̰
					SetFocus(nSelSprite);
					//PA_OutputText(1, 2, 1, "sprite[%d] x[%d]y[%d]",nSelSprite, stCurTangram.nX[nSelSprite], stCurTangram.nY[nSelSprite]); // Letter recognized

					if(CheckAnswerTangram(stAnswerTangram[nAnswerIdx]))
					{
						//PA_OutputText(1, 2, 0,"OK collect");
						
					}
				}
			}
			else if(Pad.Held.Left)
			{
				SleepDS(1);
				if(stCurTangram.nX[nSelSprite]>8)
				{
					stCurTangram.nX[nSelSprite]=stCurTangram.nX[nSelSprite]-4;

					PA_3DSetSpriteXY(nSelSprite,stCurTangram.nX[nSelSprite],stCurTangram.nY[nSelSprite]);//8pixel  ̰
					SetFocus(nSelSprite);
					//PA_OutputText(1, 2, 1, "sprite[%d] x[%d]y[%d]",nSelSprite, stCurTangram.nX[nSelSprite], stCurTangram.nY[nSelSprite]); // Letter recognized

					if(CheckAnswerTangram(stAnswerTangram[nAnswerIdx]))
					{
						//PA_OutputText(1, 2, 0,"OK collect");
						
					}
				}
			}
			else if(Pad.Held.Right)
			{
				SleepDS(1);
				if(stCurTangram.nX[nSelSprite]<248)
				{
					stCurTangram.nX[nSelSprite]=stCurTangram.nX[nSelSprite]+4;

					PA_3DSetSpriteXY(nSelSprite,stCurTangram.nX[nSelSprite],stCurTangram.nY[nSelSprite]);//8pixel  ̰
					SetFocus(nSelSprite);
					//PA_OutputText(1, 2, 1, "sprite[%d] x[%d]y[%d]",nSelSprite, stCurTangram.nX[nSelSprite], stCurTangram.nY[nSelSprite]); // Letter recognized

					if(CheckAnswerTangram(stAnswerTangram[nAnswerIdx]))
					{
						//PA_OutputText(1, 2, 0,"OK collect");
						
					}
				}
			}
			//flip
			if(Pad.Newpress.X)
			{
				if(nSelSprite==6)
				{
					stCurTangram.bFlip=!stCurTangram.bFlip;
					PA_3DSetSpriteVflip(nSelSprite, stCurTangram.bFlip);
				}
				else
				{
					stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]-256; 
					stCurTangram.nAngle[nSelSprite] &= 511;
					PA_3DSetSpriteRotate(nSelSprite, stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
				}
				SetFocus(nSelSprite);
				CheckAnswerTangram(stAnswerTangram[nAnswerIdx]);
			}
			else if(Pad.Newpress.B)
			{
				if(nSelSprite==6)
				{
					stCurTangram.bFlip=!stCurTangram.bFlip;
					PA_3DSetSpriteVflip(nSelSprite, stCurTangram.bFlip);
				}
				else
				{
					stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]+256; 
					stCurTangram.nAngle[nSelSprite] &= 511;
					PA_3DSetSpriteRotate(nSelSprite, stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
				}
				SetFocus(nSelSprite);
				CheckAnswerTangram(stAnswerTangram[nAnswerIdx]);
			}
			//rotate
			if(Pad.Newpress.Y)
			{
				stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]+64; 
					stCurTangram.nAngle[nSelSprite] &= 511;
					PA_3DSetSpriteRotate(nSelSprite, 
								   stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
				SetFocus(nSelSprite);
				CheckAnswerTangram(stAnswerTangram[nAnswerIdx]);
			}
			else if(Pad.Newpress.A)
			{
				stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]-64; 
					stCurTangram.nAngle[nSelSprite] &= 511;
					PA_3DSetSpriteRotate(nSelSprite, 
								   stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
				SetFocus(nSelSprite);
				CheckAnswerTangram(stAnswerTangram[nAnswerIdx]);
			}

			for(i=0;i<7;i++)
			{
				
				/*if(Stylus.X > pa_3dsprites[i].X&&Stylus.X < pa_3dsprites[i].X+pa_3dsprites[i].Width \
					&&Stylus.Y > pa_3dsprites[i].Y&&Stylus.Y < pa_3dsprites[i].Y+pa_3dsprites[i].Height &&Stylus.Newpress)*/
				if(PA_3DSpriteTouched(i)&&Stylus.Newpress)
				{
					nSelSprite=i;
					PA_3DSetSpritePrio(i, 1024 + 10);
					SetFocus(nSelSprite);
				}
				else
					PA_3DSetSpritePrio(i, 1024 + 5 );
			}

			/*if(Stylus.X > pa_3dsprites[nSelSprite].X&&Stylus.X < pa_3dsprites[nSelSprite].X+pa_3dsprites[nSelSprite].Width \
					&&Stylus.Y > pa_3dsprites[nSelSprite].Y&&Stylus.Y < pa_3dsprites[nSelSprite].Y+pa_3dsprites[nSelSprite].Height &&Stylus.Held)*/
			if(PA_3DSpriteTouched(nSelSprite)&&Stylus.Held)
			{
				stCurTangram.nX[nSelSprite]=Stylus.X-(Stylus.X&3);
				stCurTangram.nY[nSelSprite]=Stylus.Y-(Stylus.Y&3);
				PA_3DSetSpriteXY(nSelSprite,stCurTangram.nX[nSelSprite],stCurTangram.nY[nSelSprite]);//4pixel  ̰
				SetFocus(nSelSprite);
				//PA_OutputText(1, 2, 1, "sprite[%d] x[%d]y[%d]",nSelSprite, stCurTangram.nX[nSelSprite], stCurTangram.nY[nSelSprite]); // Letter recognized

				if(CheckAnswerTangram(stAnswerTangram[nAnswerIdx]))
				{
					//PA_OutputText(1, 2, 0,"OK collect");
					
				}
					
			}
			if(!PA_3DSpriteTouched(NUM_SEARCH_SPRITE)&&!PA_3DSpriteTouched(nSelSprite)&&Stylus.Released)
			{
				switch(letter[0])
				{
				case 'L':
					if(nSelSprite==6)
					{
						stCurTangram.bFlip=!stCurTangram.bFlip;
						PA_3DSetSpriteVflip(nSelSprite, stCurTangram.bFlip);
					}
					else
					{
						stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]-256; 
						stCurTangram.nAngle[nSelSprite] &= 511;
						PA_3DSetSpriteRotate(nSelSprite, // rotset
									   stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
					}
					break;
				case 'R':
					if(nSelSprite==6)
					{
						stCurTangram.bFlip=!stCurTangram.bFlip;
						PA_3DSetSpriteVflip(nSelSprite, stCurTangram.bFlip);
					}
					else
					{
						stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]-256; 
						stCurTangram.nAngle[nSelSprite] &= 511;
						PA_3DSetSpriteRotate(nSelSprite, stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
					}
					break;
				case 'U':
					if(nSelSprite==6)
					{
						stCurTangram.bFlip=!stCurTangram.bFlip;
						PA_3DSetSpriteVflip(nSelSprite, stCurTangram.bFlip);
					}
					else
					{
						stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]+256; 
						stCurTangram.nAngle[nSelSprite] &= 511;
						PA_3DSetSpriteRotate(nSelSprite, stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
					}
					break;
				case 'D':
					if(nSelSprite==6)
					{
						stCurTangram.bFlip=!stCurTangram.bFlip;
						PA_3DSetSpriteVflip(nSelSprite, stCurTangram.bFlip);
					}
					else
					{
						stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]+256; 
						stCurTangram.nAngle[nSelSprite] &= 511;
						PA_3DSetSpriteRotate(nSelSprite, stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
					}
					break;
				case 'N': case 'E':
					stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]-64; 
					stCurTangram.nAngle[nSelSprite] &= 511;
					PA_3DSetSpriteRotate(nSelSprite, 
								   stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
					break;
				case 'S': case 'W':
					stCurTangram.nAngle[nSelSprite] = stCurTangram.nAngle[nSelSprite]+64; 
					stCurTangram.nAngle[nSelSprite] &= 511;
					PA_3DSetSpriteRotate(nSelSprite, 
								   stCurTangram.nAngle[nSelSprite]); // angle, from 0 to 511
					break;
				}
				SetFocus(nSelSprite);
				//PA_3DProcess();  // Update sprites
				//PA_WaitForVBL();
				//PA_OutputText(1, 2, 0, "Shape : %s", PA_RecoShape); // Write the shape string
				letter[0]='0';
				CheckAnswerTangram(stAnswerTangram[nAnswerIdx]);
				
			}
			if(PA_3DSpriteTouched(NUM_SEARCH_SPRITE)&&bHelpUse==false)
			{
				//WritePosition();
				SetRandom();
			}
			/*if(Pad.Newpress.Start)
			{
				if(nAnswerIdx>0)
					nAnswerIdx--;
				ShowAnswer();
				
			}
			if(Pad.Newpress.Select)
			{
				if(nAnswerIdx<NUM_MAX_TANGRAM-1)
					nAnswerIdx++;
				ShowAnswer();
			}*/
			if(Pad.Newpress.Select)
			{
				PA_SetSpriteAnim(SCREEN_TOP,0,1);
				bNewGame=true;
			}

			PA_3DProcess();  // Update sprites
			PA_WaitForVBL();

			
		}
	}
	return 0;
}

void InitTangram()
{
	u8 i;
	bHelpUse=false;
	PA_3DSetSpriteFrame(NUM_SEARCH_SPRITE,bHelpUse);

	for(i=0;i<7;i++)
	{
		stCurTangram.nX[i]=stAnswerTangram[0].nX[i];
		stCurTangram.nY[i]=stAnswerTangram[0].nY[i];
		stCurTangram.nAngle[i]=stAnswerTangram[0].nAngle[i];
	}
	stCurTangram.bFlip=stAnswerTangram[0].bFlip;

	for(i=0;i<7;i++)
	{
		PA_3DSetSpriteXY(i,stAnswerTangram[0].nX[i],stAnswerTangram[0].nY[i]);
		PA_3DSetSpriteRotate(i,stAnswerTangram[0].nAngle[i]);
		if(i==6)
			PA_3DSetSpriteVflip(i, stAnswerTangram[0].bFlip);
	}
	
	SetFocus(0);
}

void SetSummaryFocus(u8 nPosX, u8 nPosY)
{
	//PA_DeleteBg (SCREEN_TOP, BG_SUMMARY);

	switch(nPosY)
	{
	case 0: case 1: case 2:
		if(nPosX<4)
		{
			PA_LoadTiledBg(SCREEN_TOP,BG_SUMMARY,summary1);
			PA_SetSpriteXY(SCREEN_TOP,0,64*nPosX,64*nPosY);
		}
		else
		{
			PA_LoadTiledBg(SCREEN_TOP,BG_SUMMARY,summary2);
			PA_SetSpriteXY(SCREEN_TOP,0,64*(nPosX-4),64*nPosY);
		}
		break;
	case 3: case 4: case 5:
		if(nPosX<4)
		{
			PA_LoadTiledBg(SCREEN_TOP,BG_SUMMARY,summary3);
			PA_SetSpriteXY(SCREEN_TOP,0,64*nPosX,64*(nPosY-3));
		}
		else
		{
			PA_LoadTiledBg(SCREEN_TOP,BG_SUMMARY,summary4);
			PA_SetSpriteXY(SCREEN_TOP,0,64*(nPosX-4),64*(nPosY-3));
		}
		break;
	case 6: case 7: case 8:
		if(nPosX<4)
		{
			PA_LoadTiledBg(SCREEN_TOP,BG_SUMMARY,summary5);
			PA_SetSpriteXY(SCREEN_TOP,0,64*nPosX,64*(nPosY-6));
		}
		else
		{
			PA_LoadTiledBg(SCREEN_TOP,BG_SUMMARY,summary6);
			PA_SetSpriteXY(SCREEN_TOP,0,64*(nPosX-4),64*(nPosY-6));
		}
		break;
	}

	PA_WaitForVBL();
}

void SetFocus(u8 nSelSprite)
{
	u8 nFocusSprite=21;
	u8 nAngle=0;

	PA_3DSetSpriteXY(21,-64, 192-32);
	PA_3DSetSpriteXY(22, 128+16, -33);
	PA_3DSetSpriteXY(23, 256+32, 16);

	switch(nSelSprite)
	{
	case 0: case 1:
		nFocusSprite=21;
		break;
	case 2: case 6:
		nFocusSprite=22;
		break;
	case 3: case 4: case 5:
		nFocusSprite=23;
		break;
	}
	PA_3DSetSpriteXY(nFocusSprite,stCurTangram.nX[nSelSprite],stCurTangram.nY[nSelSprite]);
	PA_3DSetSpriteRotate(nFocusSprite,stCurTangram.nAngle[nSelSprite]);
	if(nSelSprite==6)
	{
		nAngle=stCurTangram.nAngle[nSelSprite]+128; 
		nAngle &= 511;
		PA_3DSetSpriteRotate(nFocusSprite,nAngle);
	}
	PA_3DProcess();
	PA_WaitForVBL();
}

bool CheckAnswerTangram(TANGRAM stAnswer)
{

	//PA_OutputText(1, 2, 1, "sprite[%d] x[%d]y[%d]",nSelSprite, stCurTangram.nX[nSelSprite], stCurTangram.nY[nSelSprite]); // Letter recognized
	//PA_OutputText(1, 2, 2, "flip:[%d] angle:[%d]", stCurTangram.bFlip, stCurTangram.nAngle[nSelSprite]); 
	//PA_WaitForVBL();

	if(stCurTangram.bFlip==stAnswer.bFlip)
	{
		//middle triangle
		if(stCurTangram.nX[2]==stAnswer.nX[2]&&stCurTangram.nY[2]==stAnswer.nY[2]&&stCurTangram.nAngle[2]==stAnswer.nAngle[2])
		{
			//square
			if((stCurTangram.nX[5]==stAnswer.nX[5])&&(stCurTangram.nY[5]==stAnswer.nY[5]) \
				&&((stCurTangram.nAngle[5]==stAnswer.nAngle[5])||(((stCurTangram.nAngle[5]+128)&511)==stAnswer.nAngle[5]) \
				||(((stCurTangram.nAngle[5]+256)&511)==stAnswer.nAngle[5])||(((stCurTangram.nAngle[5]+384)&511)==stAnswer.nAngle[5]) \
				||(((stCurTangram.nAngle[5]-128)&511)==stAnswer.nAngle[5])||(((stCurTangram.nAngle[5]-256)&511)==stAnswer.nAngle[5])||(((stCurTangram.nAngle[5]-384)&511)==stAnswer.nAngle[5]) ))
			{
				//parrellel 
				if((stCurTangram.nX[6]==stAnswer.nX[6])&&(stCurTangram.nY[6]==stAnswer.nY[6])&&((stCurTangram.nAngle[6]==stAnswer.nAngle[6]) \
					||(((stCurTangram.nAngle[6]+256)&511)==stAnswer.nAngle[6])||(((stCurTangram.nAngle[6]-256)&511)==stAnswer.nAngle[6]) ))
				{
					//large triangle
					if((stCurTangram.nX[0]==stAnswer.nX[0]&&stCurTangram.nY[0]==stAnswer.nY[0]&&stCurTangram.nAngle[0]==stAnswer.nAngle[0] \
						&&stCurTangram.nX[1]==stAnswer.nX[1]&&stCurTangram.nY[1]==stAnswer.nY[1]&&stCurTangram.nAngle[1]==stAnswer.nAngle[1]) \
						||(stCurTangram.nX[0]==stAnswer.nX[1]&&stCurTangram.nY[0]==stAnswer.nY[1]&&stCurTangram.nAngle[0]==stAnswer.nAngle[1] \
						&&stCurTangram.nX[1]==stAnswer.nX[0]&&stCurTangram.nY[1]==stAnswer.nY[0]&&stCurTangram.nAngle[1]==stAnswer.nAngle[0]))
					{
						//small triangle
						if((stCurTangram.nX[3]==stAnswer.nX[3]&&stCurTangram.nY[3]==stAnswer.nY[3]&&stCurTangram.nAngle[3]==stAnswer.nAngle[3] \
						&&stCurTangram.nX[4]==stAnswer.nX[4]&&stCurTangram.nY[4]==stAnswer.nY[4]&&stCurTangram.nAngle[4]==stAnswer.nAngle[4]) \
						||(stCurTangram.nX[3]==stAnswer.nX[4]&&stCurTangram.nY[3]==stAnswer.nY[4]&&stCurTangram.nAngle[3]==stAnswer.nAngle[4] \
						&&stCurTangram.nX[4]==stAnswer.nX[3]&&stCurTangram.nY[4]==stAnswer.nY[3]&&stCurTangram.nAngle[4]==stAnswer.nAngle[3]))
						{
							PA_PlaySimpleSound(0,win);
							
							if(nAnswerIdx<NUM_MAX_TANGRAM-1)
							{
								nAnswerIdx++;
								if(nFocusX<7)
								{
									nFocusX++;
								}
								else
								{
									nFocusX=0;
									nFocusY++;
								}
							}
							else
							{
								nAnswerIdx=1;
								nFocusX=0;
								nFocusY=0;
							}
							SleepDS(20);
							SetSummaryFocus(nFocusX, nFocusY);
							InitTangram();
							ArrangeTangramBg(stAnswerTangram[nAnswerIdx]);
							return true;
						}
						else
						{
							//PA_OutputText(1, 2, 0,"small not answer");
							return false;
						}
					}
					else
					{
						//PA_OutputText(1, 2, 0,"large not answer");
						return false;
					}
				}
				else 
				{
					//PA_OutputText(1, 2, 0,"parrellel not answer");
					return false;
				}
			}
			else
			{
				//PA_OutputText(1, 2, 0,"square not answer");
				return false;
			}
		}
		else
		{
			//PA_OutputText(1, 2, 0,"middle not answer");
			return false;
		}
	}
	else
	{
		//PA_OutputText(1, 2, 0,"flip not answer");
		return false;
	}

}

void WritePosition()
{
	u8 i;
	//FILE* testWrite = fopen ("tangram.txt", "wb"); //wb = create/truncate & write 
	char strMsg[64];
	memset(strMsg,0x00,64);
	for(i=0;i<7;i++)
	{
		sprintf(strMsg,"[%d]nX[%d]nY[%d]A[%d]F[%d]\r\n",i,stCurTangram.nX[i],stCurTangram.nY[i],stCurTangram.nAngle[i],stCurTangram.bFlip);
		PA_OutputText(1, 0, 4+i, "%s",strMsg);
		//fwrite(strMsg, 64, 1, testWrite);
	}
	//fclose(testWrite);
	PA_WaitForVBL();
}

void ArrangeTangramBg(TANGRAM stAnswer)
{
	u8 i;
	for(i=0;i<7;i++)
	{
		PA_3DSetSpriteXY(i+10,stAnswer.nX[i],stAnswer.nY[i]);
		PA_3DSetSpriteRotate(i+10,stAnswer.nAngle[i]);
		if(i==6)
			PA_3DSetSpriteVflip(i+10, stAnswer.bFlip);
	}
	PA_3DProcess();  // Update sprites
	PA_WaitForVBL();
}

void SetRandom()
{
	if(nAnswerIdx>=NUM_MAX_TANGRAM)
		return;
	u8 i;
	PA_InitRand();
	i = PA_RandMax(6);//0~6

	stCurTangram.nX[i]=stAnswerTangram[nAnswerIdx].nX[i];
	stCurTangram.nY[i]=stAnswerTangram[nAnswerIdx].nY[i];
	stCurTangram.nAngle[i]=stAnswerTangram[nAnswerIdx].nAngle[i];
	

	PA_3DSetSpriteXY(i,stAnswerTangram[nAnswerIdx].nX[i],stAnswerTangram[nAnswerIdx].nY[i]);
	PA_3DSetSpriteRotate(i,stAnswerTangram[nAnswerIdx].nAngle[i]);
	if(i==6)
	{
		stCurTangram.bFlip=stAnswerTangram[nAnswerIdx].bFlip;
		PA_3DSetSpriteVflip(i, stAnswerTangram[nAnswerIdx].bFlip);
	}
	SetFocus(i);
	bHelpUse=true;
	PA_3DSetSpriteFrame(NUM_SEARCH_SPRITE,bHelpUse);

	PA_3DProcess();  // Update sprites
	PA_WaitForVBL();
}

void SetAnswer()
{
	if(nAnswerIdx>=NUM_MAX_TANGRAM)
		return;
	u8 i;
	for(i=0;i<7;i++)
	{
		PA_3DSetSpriteXY(i,stAnswerTangram[nAnswerIdx].nX[i],stAnswerTangram[nAnswerIdx].nY[i]);
		PA_3DSetSpriteRotate(i,stAnswerTangram[nAnswerIdx].nAngle[i]);
		if(i==6)
		{
			PA_3DSetSpriteVflip(i, stAnswerTangram[nAnswerIdx].bFlip);
		}
	}
	PA_3DProcess();  // Update sprites
	PA_WaitForVBL();
}


void ShowAnswer()
{
	if(nAnswerIdx>=NUM_MAX_TANGRAM)
		return;
	u8 i;
	for(i=0;i<7;i++)
	{
		PA_3DSetSpriteXY(i+10,stAnswerTangram[nAnswerIdx].nX[i],stAnswerTangram[nAnswerIdx].nY[i]);
		PA_3DSetSpriteRotate(i+10,stAnswerTangram[nAnswerIdx].nAngle[i]);
		if(i==6)
		{
			PA_3DSetSpriteVflip(i+10, stAnswerTangram[nAnswerIdx].bFlip);
		}
	}
	PA_3DProcess();  // Update sprites
	PA_WaitForVBL();
}

void SleepDS(u8 secs) 
{
	u8 x;

	for (x=0; x<secs*6; x++) {
		PA_WaitForVBL();
	}
}
